<template>
    <v-row>
        <v-col>
            <v-row>
                <v-col class="py-0" cols="12">
                    <v-card>
                        <v-card-title>
                            <span class="title font-weight-bold">{{ $tc('order', 1) }} #{{ id }}</span>
                            <v-spacer></v-spacer>
                            <v-skeleton-loader
                                :loading="loading"
                                type="chip"
                                tile
                            >
                                <div class="field-label d-inline-flex">{{ $t('business_type' )}}</div>
                                <v-chip
                                    class="subtitle-1 font-weight-bold status--pending mr-5"
                                    text-color="white"
                                    label
                                >
                                    {{ order.business_type.name }}
                                </v-chip>

                                <div class="field-label d-inline-flex">{{ $t('status' )}}</div>
                                <v-chip
                                    class="subtitle-1 font-weight-bold"
                                    :class="`status--${order.status.name}`"
                                    text-color="white"
                                    label
                                    v-if="!isPickupRequested || partialReturned"
                                >
                                    {{ $t(order.status.name) }}
                                </v-chip>

                                <v-chip
                                    class="subtitle-1 font-weight-bold"
                                    :class="`status--${order.status.name}`"
                                    text-color="white"
                                    label
                                    v-if="isPickupRequested && !partialReturned"
                                >
                                    {{$t('return')}}
                                </v-chip>

                                <v-chip
                                    class="subtitle-1 font-weight-bold"
                                    :class="`status--${order.status.name}`"
                                    text-color="white"
                                    label
                                    v-if="isStatusDelivered && !isPickupRequested && !isBusinessTypeShop"
                                >
                                    {{$t('in_use')}}
                                </v-chip>
                            </v-skeleton-loader>
                        </v-card-title>

                        <v-divider></v-divider>

                        <v-card-text>
                            <div class="title field-label font-weight-bold">
                                {{ $t('order_', [$t('summary')]) }}
                            </div>
                            <order-item :order="order" :loading="loading"></order-item>
                        </v-card-text>
                    </v-card>
                </v-col>
                <v-col cols="12">
                    <v-card>
                        <v-card-title>
                            <div class="title field-label font-weight-bold">
                                {{ $t('order_', [$t('timeline')]) }}
                            </div>
                        </v-card-title>
                        <v-card-text>
                            <order-timeline
                                :order="order"
                                :loading="loading"
                            ></order-timeline>
                        </v-card-text>
                    </v-card>
                </v-col>

                <v-col cols="12" v-if="isStatusApproved && order.timeslots.length === 0">
                    <v-card>
                        <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                            <v-card-title>
                                <div class="field-label">{{ $t('timeslot_',[$t('deliver')]) }}</div>
                            </v-card-title>
                            <v-card-text>
                                <v-row class="justify-center">
                                    <v-col cols="6">
                                        <ValidationProvider v-slot="{ errors }" name="timeslotDate" rules="required">
                                            <v-date-picker
                                                v-model="timeslotDate"
                                                year-icon="mdi-calendar-blank"
                                                prev-icon="mdi-skip-previous"
                                                next-icon="mdi-skip-next"
                                                full-width
                                                :min="dateToday"
                                            ></v-date-picker>
                                        </ValidationProvider>
                                    </v-col>
                                    <v-col cols="'6">
                                        <ValidationProvider :name="$tc('timeslot',1)" rules="required" v-slot="{ errors }">
                                            <v-select
                                                dense
                                                outlined
                                                v-model="deliverTimeslot"
                                                :loading="loading"
                                                :items="deliverTimeslots"
                                                :error-messages="errors"
                                                hide-details="auto"
                                                item-text="start_time ~ end_time"
                                                item-value="id"
                                                :menu-props="{ bottom: true, offsetY: true }"
                                            >
                                                <template slot="selection" slot-scope="data">
                                                    {{ data.item.start_time + '~' + data.item.end_time}}
                                                </template>
                                                <template slot="item" slot-scope="data">
                                                    {{ data.item.start_time + '~' + data.item.end_time}}
                                                </template>
                                            </v-select>
                                        </ValidationProvider>
                                    </v-col>
                                </v-row>

                            </v-card-text>
                        </ValidationObserver>
                    </v-card>
                </v-col>

                <v-col cols="12" v-if="(order.tracks.length || disableScanTag) && order.timeslots.length > 0">
                    <v-card>
                        <v-card-title>
                            <div class="field-label">{{ $t('scanned_', [$t('tag')]) }}</div>
                        </v-card-title>
                        <v-card-text>
                            <v-chip-group readonly>
                                <v-chip
                                    v-for="inventory in order.tracks"
                                    :key="inventory.id"
                                    color="primary"
                                    readonly
                                    label
                                >
                                    {{ inventory.tag }} | {{ inventory.stock.product.name }} @ {{ inventory.scanned_at | datetime }}

                                    <v-icon
                                        class="pl-2"
                                        @click="openRemoveReservedTagDialog(inventory)"
                                        v-if="disableScanTag"
                                    >
                                        mdi-close
                                    </v-icon>
                                </v-chip>
                            </v-chip-group>
                        </v-card-text>

                        <v-container class="pa-0" v-if="disableScanTag">
                            <v-row v-if="!completed" justify="center">
                                <v-col cols="3">
                                    <v-btn
                                        @click="scanDialog = true"
                                        :loading="loading"
                                        color="primary"
                                        block
                                    >
                                        <v-icon left>mdi-barcode-scan</v-icon>
                                        {{ $t('scan') }}
                                    </v-btn>
                                </v-col>
                            </v-row>
                        </v-container>
                    </v-card>
                </v-col>
                <v-col cols="12">
                    <v-container class="pa-0">
                        <v-row v-if="!completed && !partialReturned" justify="center">
                            <v-col cols="3">
                                <v-btn
                                    @click="rejectDialog = true"
                                    :loading="loading"
                                    :disabled="disableReject"
                                    color="error"
                                    block
                                >
                                    {{ $t('reject') }}
                                </v-btn>
                            </v-col>
                            <v-col cols="3">
                                <v-btn
                                    @click="onAction()"
                                    :loading="loading"
                                    :disabled="disableConfirm"
                                    color="primary"
                                    block
                                >
                                    <v-icon v-if="isStatusDelivered" left>mdi-barcode-scan</v-icon>
                                    {{ actionText }}
                                </v-btn>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-col>
            </v-row>
        </v-col>
        <v-col cols="4">
            <v-card>
                <v-card-title class="pb-0">
                    <div class="field-label">{{ $t('customer') }}</div>
                </v-card-title>
                <v-card-text class="pa-0">
                    <v-list dense>
                        <v-list-item>
                            <v-list-item-content>
                                <v-skeleton-loader
                                    :loading="loading"
                                    type="text"
                                >
                                    <span class="field-label subtitle-1 font-weight-bold">
                                        {{ order.user.profile.name }}
                                    </span>
                                </v-skeleton-loader>
                            </v-list-item-content>
                        </v-list-item>
                        <v-divider></v-divider>
                        <v-list-item>
                            <v-list-item-content>
                                <v-skeleton-loader
                                    :loading="loading"
                                    type="text"
                                >
                                    <v-icon color="light-blue darken-3">mdi-phone</v-icon>
                                    <span class="subtitle-1 light-blue--text text--darken-3">
                                        {{ order.user.profile.mobile }}
                                    </span>
                                </v-skeleton-loader>
                            </v-list-item-content>
                        </v-list-item>
                        <v-list-item>
                            <v-list-item-content>
                                <v-skeleton-loader
                                    :loading="loading"
                                    type="text"
                                >
                                    <v-icon color="light-blue darken-3">mdi-email</v-icon>
                                    <span class="subtitle-1 light-blue--text text--darken-3">
                                        {{ order.user.email }}
                                    </span>
                                </v-skeleton-loader>
                            </v-list-item-content>
                        </v-list-item>
                        <v-divider></v-divider>
                        <v-list-item>
                            <v-list-item-content>
                                <div class="field-label subtitle-1 font-weight-bold pb-2">{{ $t('shipping_address') }}</div>
                                <v-skeleton-loader
                                    :loading="loading"
                                    type="sentences"
                                >
                                    <div class="subtitle-2 address">
                                        {{ order.shipping_address.name }}, {{ order.shipping_address.company }}
                                    </div>
                                    <div class="subtitle-2 address">
                                        {{ order.shipping_address.address_1 }}, {{ order.shipping_address.address_2 }}
                                    </div>
                                    <div class="subtitle-2 address">
                                        {{ order.shipping_address.city }}, {{ order.shipping_address.state }}, {{ order.shipping_address.country }}, {{ order.shipping_address.postcode }}
                                    </div>
                                    <div class="subtitle-2 address">
                                        {{ order.shipping_address.mobile }}
                                    </div>
                                </v-skeleton-loader>
                            </v-list-item-content>
                        </v-list-item>
                    </v-list>
                </v-card-text>
            </v-card>
        </v-col>

        <v-dialog
            v-if="approveDialog"
            v-model="approveDialog"
            max-width="420"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('approve_', [$tc('order', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('approve_desc_1') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="approveDialog = false"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="approveOrder"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="attachTimeslotDialog"
            v-model="attachTimeslotDialog"
            max-width="420"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('attach_timeslot_', [$tc('order', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('attach_timeslot_desc_1') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="attachTimeslotDialog = false"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="attachTimeslot"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="readyShipDialog"
            v-model="readyShipDialog"
            max-width="420"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('ready_for_ship_', [$tc('order', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('ready_for_ship_desc_1') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="readyShipDialog = false"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="readyShipOrder"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="deliveredDialog"
            v-model="deliveredDialog"
            max-width="420"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('deliver_', [$tc('order', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('deliver_desc_1') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="deliveredDialog = false"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="deliverOrder"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="scanDialog"
            v-model="scanDialog"
            max-width="720"
        >
            <v-card>
                <v-card-text class="pa-2">
                    <scan-tag
                        :return-object="requiredTagObject"
                        :statuses="statuses"
                        :loading="loading"
                        @confirmed="onConfirm"
                    ></scan-tag>
                </v-card-text>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="removeReserveTagDialog"
            v-model="removeReserveTagDialog"
            max-width="420"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('remove_', [$tc('reserved_tag', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('reserved_tag_desc_1') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="removeReserveTagDialog = false"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="removeReserveTag()"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-model="rejectDialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('reject_', [$tc('order', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('reject_desc_1') }}</p>
                    <p>{{ $t('reject_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="rejectDialog = false"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="rejectOrder"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import OrderStatus from "../../../constants/order"
    import BusinessType from "../../../constants/businessType"
    import Timeslot from "../../../constants/timeslot"
    import OrderItem from "./OrderItem";
    import { mapMutations } from "vuex";
    import { ValidationObserver, ValidationProvider } from "vee-validate";
    import OrderTimeline from "./OrderTimeline";
    import ScanTag from "../tags/ScanTag";

    export default {
        name: 'OrderShow',
        components: {
            ScanTag,
            OrderTimeline,
            OrderItem,
            ValidationObserver,
            ValidationProvider,
        },
        props: ['id'],
        data: () => ({
            order: {
                items: [],
                user: {
                    email: '',
                    profile: {
                        name: '',
                        mobile: ''
                    }
                },
                status: {
                    id: null,
                    name: ''
                },
                shipping_address: {
                    name: '',
                    company: '',
                    address_1: '',
                    address_2: '',
                    city: '',
                    state: '',
                    country: '',
                    postcode: '',
                    mobile: '',
                },
                timeslots:null,
                tracks: [],
                invoice: null,
                order_at: null,
                updated_at: null,
                shipped_at: null,
                approved_at: null,
                shipping_at: null,
                return_at: null,
                pick_up_requested_at: null,
            },
            tags: [],
            removableReservedTags: [],
            loading: false,
            promptEnterTag: false,
            rejectDialog: false,
            scanDialog: false,
            removeReserveTagDialog: false,
            approveDialog: false,
            readyShipDialog:false,
            deliveredDialog:false,
            attachTimeslotDialog:false,
            returnDialog:false,
            statuses: [],
            deliverTimeslots:[],
            deliverTimeslot:[],
            timeslotDate: (new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000 + 86400000)).toISOString().substr(0, 10),
            dateToday: (new Date(Date.now() - (new Date()).getTimezoneOffset() * 60000 + 86400000)).toISOString().substr(0, 10),
        }),
        created() {
            this.fetchOrder();
            this.fetchStatus();
            this.fetchTimeslots()
        },
        computed: {
            getOneDayAfterToday(){
                let date = new Date(this.dateToday).toISOString().substr(0, 10);
                return date.setDate(date.getDate() + 1).toString();
            },
            disableReject() {
                return this.loading || (
                    this.order.status.id === OrderStatus.REJECTED ||
                    this.order.status.id === OrderStatus.COMPLETED ||
                    this.order.status.id === OrderStatus.DELIVERED ||
                    this.order.status.id === OrderStatus.REFUND ||
                    this.order.status.id === OrderStatus.CANCELLED ||
                    this.order.status.id === OrderStatus.SHIPPING ||
                    this.order.status.id === OrderStatus.APPROVED ||
                    this.order.status.id === OrderStatus.PARTIAL_RETURNED
                )
            },
            disableConfirm() {
                const status = this.order.status.id;

                return this.loading || (
                    status === OrderStatus.REFUND
                    || status === OrderStatus.CANCELLED
                    || status === OrderStatus.FAILED
                    || status === OrderStatus.REJECTED
                    || status === OrderStatus.COMPLETED
                    || status === OrderStatus.PARTIAL_RETURNED
                )
            },
            isStatusDelivered() {
                const status = this.order.status.id;

                return status === OrderStatus.DELIVERED
            },
            isStatusApproved() {
                const status = this.order.status.id;

                return status === OrderStatus.APPROVED
            },
            isPickupRequested() {
                const pickupRequested = this.order.pick_up_requested_at && !this.order.return_at;

                return pickupRequested;
            },
            isBusinessTypeShop() {
                const shopBusinessType = this.order.business_type_id === BusinessType.SHOP;

                return shopBusinessType;
            },
            disableScanTag() {
                const status = this.order.status.id;

                return status === OrderStatus.APPROVED || status === OrderStatus.PARTIAL_RETURNED
            },
            showDeliverTags() {
                return this.order.status.id === OrderStatus.DELIVERED;
            },
            shippedTags() {
                return this.order.tracks.map(i => i.tag).join("\n");
            },
            completed() {
                return this.order.status.id === OrderStatus.COMPLETED
            },
            partialReturned() {
                return this.order.status.id === OrderStatus.PARTIAL_RETURNED
            },
            requiredTagObject() {
                return this.order.status.id === OrderStatus.DELIVERED || this.order.status.id === OrderStatus.PARTIAL_RETURNED;
            },
            actionText() {
                const status = this.order.status.id;

                if(status === OrderStatus.PENDING) {
                    return this.$t('approve');
                }
                else if(status === OrderStatus.APPROVED && this.order.timeslots.length > 0) {
                    return this.$t('ready_for_ship');
                }
                else if(status === OrderStatus.APPROVED && this.order.timeslots.length === 0) {
                    return this.$t('attach');
                }
                else if(status === OrderStatus.SHIPPING) {
                    return this.$t('delivered');
                }
                else if(status === OrderStatus.DELIVERED) {
                    return this.$t('return');
                }
            }
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),
            fetchTimeslots() {
                return new Promise((resolve, reject) => {
                    axios.get('api/timeslots?filter={"type":['+ Timeslot.DELIVER +']}')
                        .then(({ data }) => {
                            this.deliverTimeslots = data.data
                        })
                        .catch(({ response }) => {
                            reject(response.data)
                        })
                })
            },
            fetchStatus() {
                axios.get('api/stocks/status')
                    .then(({ data }) => {
                        this.statuses = data;
                    })
            },
            fetchOrder() {
                this.loading = true;

                axios.get(`api/orders/${this.id}`)
                    .then(({ data }) => {
                        this.order = data;
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },
            rejectOrder() {
                this.loading = true;

                axios.put(`api/orders/${this.id}/reject`)
                    .then(({ data }) => {
                        this.order = data;
                        this.success(this.$t('order_action.reject'));
                        this.rejectDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },

            async approveOrder() {
                this.loading = true;

                axios.put(`api/orders/${this.id}/approve`)
                    .then(({ data }) => {
                        this.fetchOrder();
                        this.success(this.$t('order_action.approved'));
                        this.approveDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },

            async readyShipOrder(tags) {
                this.loading = true;

                axios.put(`api/orders/${this.id}/ship`,{
                    tags: tags
                })
                    .then(({ data }) => {
                        this.fetchOrder();
                        this.success(this.$t('order_action.shipping'));
                        this.readyShipDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },

            async deliverOrder() {
                this.loading = true;

                axios.put(`api/orders/${this.id}/deliver`)
                    .then(({ data }) => {
                        this.success(this.$t('order_action.deliver'));
                        this.fetchOrder();
                        this.deliveredDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                        this.loading = false;
                    })
            },
            async returnOrder(tags) {
                this.loading = true;

                axios.put(`api/orders/${this.id}/return`, {
                    tags: tags
                })
                    .then(({ data }) => {
                        this.success(this.$t('order_action.return'));
                        this.fetchOrder();
                        this.scanDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                        this.loading = false;
                    })
            },
            async returnPartialOrder(tags) {
                this.loading = true;

                axios.put(`api/orders/${this.id}/return/partial`, {
                    tags: tags
                })
                    .then(({ data }) => {
                        this.success(this.$t('order_action.return'));
                        this.fetchOrder();
                        this.scanDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                        this.loading = false;
                    })
            },
            async attachTimeslot(){
                this.loading = true;

                axios.post(`api/orders/${this.id}/timeslot`, {
                    timeslot: Timeslot.DELIVER,
                    timeslot_date: this.timeslotDate
                })
                    .then(({ data }) => {
                        this.success(this.$t('order_action.timeslot_deliver_attached'));
                        this.fetchOrder();
                        this.attachTimeslotDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                        this.loading = false;
                    })
            },
            async reserveTags(tags){
                this.loading = true;

                axios.post(`api/orders/${this.id}/reserve/tags`, {
                    tags: tags
                })
                    .then(({ data }) => {
                        this.success(this.$t('order_action.reserved'));
                        this.fetchOrder();
                        this.scanDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                        this.loading = false;
                    })
            },
            async removeReserveTag(){
                this.loading = true;

                axios.put(`api/orders/${this.id}/reserve/tag`, {
                    tag: this.removableReservedTags
                })
                    .then(({ data }) => {
                        this.removableReservedTags = [];
                        this.success(this.$t('order_action.reserved_removed'));
                        this.fetchOrder();
                        this.removeReserveTagDialog = false;
                    })
                    .catch(({ response }) => {
                        this.removableReservedTags = [];
                        this.error(response.data.message);
                        this.loading = false;
                    })
            },
            onConfirm(tags) {
                const status = this.order.status.id;

                if(status === OrderStatus.APPROVED) {
                    this.reserveTags(tags)
                }else if(status === OrderStatus.DELIVERED) {
                    this.returnOrder(tags);
                }else if(status === OrderStatus.PARTIAL_RETURNED) {
                    this.returnPartialOrder(tags);
                }
            },
            onAction(){
                const status = this.order.status.id;

                if(status === OrderStatus.PENDING) {
                    return this.approveDialog = true;
                }
                else if(status === OrderStatus.APPROVED && this.order.timeslots.length > 0) {
                    return this.readyShipDialog = true;
                }
                else if(status === OrderStatus.APPROVED && this.order.timeslots.length === 0) {
                    return this.attachTimeslotDialog = true;
                }
                else if(status === OrderStatus.SHIPPING) {
                    return this.deliveredDialog = true;
                }
                else if(status === OrderStatus.DELIVERED) {
                    return this.scanDialog = true;
                }
            },
            openRemoveReservedTagDialog(inventory){
                this.removableReservedTags.push(inventory.tag) ;
                this.removeReserveTagDialog = true;
            },
        }
    }
</script>

<style scoped>

</style>
